package fel.kte.it.pkropik;

import java.io.*;
import java.util.*;
import java.util.regex.Pattern;

public class PraceSeSoubory {
    public static void main(String[] args) {
        Scanner klavesnice = new Scanner(System.in);

        System.out.format("Zadejte název souboru: ");
        String nazev = klavesnice.nextLine();

        System.out.format("Zadáno: %s%n", nazev);

        nazev = nazev.replaceAll("\\s", "_");

        if (!nazev.endsWith(".txt")) {
            nazev += ".txt";
        }
        System.out.format("Zadáno: %s%n", nazev);

        File soubor = new File(nazev);
        if (!soubor.exists()) {
            try {
                if (soubor.createNewFile()) {
                    System.out.format("Soubor %s byl úspěšně vytvořen...%n", nazev);
                } else {
                    System.out.format("Soubor %s se nezdařilo vytvořit...%n", nazev);
                    return;
                }
            } catch (IOException e) {
                System.out.format("Problém s přístupem k souborovému systému...%n");
                return;
            }
        } else {
            System.out.format("Soubor %s již existuje...%n", nazev);
        }

        System.out.format("Absolutní cesta k souboru: " + soubor.getAbsolutePath() + "%n");
        try {
            System.out.format("Absolutní kánonická cesta k souboru: " + soubor.getCanonicalPath() + "%n");
        } catch (IOException e) {
            e.printStackTrace();
        }
        System.out.format("Jméno souboru: " + soubor.getName() + "%n");
        System.out.format("Rodičovská složka: " + soubor.getParent() + "%n");
        System.out.format("Cesta: " + soubor.getPath() + "%n");
        System.out.format("Je to soubor? : " + soubor.isFile() + "%n");
        System.out.format("Je to složka? :" + soubor.isDirectory() + "%n");

        System.out.format("Datum poslední změny (epoch time in millis)" + soubor.lastModified() + "%n");
        Calendar datCas = new Calendar.Builder().setInstant(soubor.lastModified()).build();

        System.out.format("Datum poslední změny: " + datCas.getTime().toString() + "%n");
        System.out.format("Porovnání data/času souboru s aktuálním časem: " + datCas.compareTo(new Calendar.Builder().setInstant(new Date()).build()) + "%n");
        System.out.format("Porovnání data/času souboru se sebou: " + datCas.compareTo(datCas) + "%n");
        Calendar nejakyCas = new Calendar.Builder().build();
        nejakyCas.set(2019, 9, 10, 1, 5, 25);
        System.out.format("Porovnání data/času souboru s datem v minulosti: " + datCas.compareTo(nejakyCas) + "%n");

        // přejmenujeme soubor
        File naPrejmenovani = new File("prejmenovany.txt");
        soubor.renameTo(naPrejmenovani);
        soubor = naPrejmenovani;
        naPrejmenovani = null;

        // smažeme soubor
        /*
        if (soubor.delete()) {
            System.out.format("Smazání souboru %s proběhlo v pořádku%n", soubor.getName());
        }
        else {
            System.out.format("Smazání souboru %s se nezdařilo%n", soubor.getName());
        }
        */
        // nastavení, bay se soubor automaticky smazal po skončení programu
        // soubor.deleteOnExit();
        System.out.format("Soubor %s existuje? : %s%n", soubor.getName(), soubor.exists() ? "existuje" : "je fuč");
        System.out.format("Délka souboru %s je %d%n", soubor.getName(), soubor.length());
        System.out.format("Soubor %s je skrytý? : %s%n", soubor.getName(), soubor.isHidden() ? "je skrytý" : "není skrytý");

        System.out.format(System.getProperty("user.dir"));
        File domovskaSlozka = new File(System.getProperty("user.dir"));

        if (domovskaSlozka.isDirectory()) {
            String[] obsahSlozky = domovskaSlozka.list();
            for (String polozka : obsahSlozky) {
                System.out.format(polozka + "%n");
            }

            System.out.format("Obsah domovské složky%n");
            File[] obsahSlozkySoubory = domovskaSlozka.listFiles();
            for (File polozka : obsahSlozkySoubory) {
                if (polozka.isDirectory()) {
                    System.out.format("složka: %s\t%s%n", polozka.getName(), (new Calendar.Builder().setInstant(polozka.lastModified()).build()).getTime());
                }
            }
            for (File polozka : obsahSlozkySoubory) {
                if (polozka.isFile()) {
                    System.out.format("soubor: %s\t%d\t%s%n", polozka.getName(), polozka.length(), (new Calendar.Builder().setInstant(polozka.lastModified()).build()).getTime());
                }
            }
        }

        try {
            FileWriter fw = new FileWriter(soubor);
            String zprava;

            zprava = String.format("35;54    Ahoj jak se máš?%n");
            fw.write(zprava);

            zprava = String.format("Jsem: %s\t%d\t%s%n", soubor.getName(), soubor.length(), (new Calendar.Builder().setInstant(soubor.lastModified()).build()).getTime());
            fw.write(zprava);

            fw.flush();
            fw.close();
        } catch (IOException ex) {
            System.out.format("Soubor nelze otevřít nebo zavřít...");
        }

        try {
            FileReader fr = new FileReader(soubor);
            String zprava;

            char[] c = new char[5];
            while (fr.ready()) {
                fr.read(c);
                System.out.print(new String(c));
                Arrays.fill(c, '\0');
            }
            fr.close();
        } catch (IOException ex) {
            System.out.format("Soubor nelze otevřít nebo zavřít...");
        }

        System.out.format("Přečteme to bufferovaně: %n");
        try {
            FileReader fr = new FileReader(soubor);
            BufferedReader in = new BufferedReader(fr);

            String zprava;

            while (in.ready()) {
                zprava = in.readLine();
                System.out.format(zprava + "%n");
            }
            fr.close();
        } catch (IOException ex) {
            System.out.format("Soubor nelze otevřít nebo zavřít...");
        }

        System.out.format("Přečteme to bytově: %n");
        try {
            FileInputStream fis = new FileInputStream(soubor);
            Scanner cteckaSouboru = new Scanner(fis);
            while (cteckaSouboru.hasNext()) {
                System.out.format(cteckaSouboru.nextLine() + "%n");
            }
            fis.close();
        } catch (IOException ex) {
            System.out.format("Soubor nelze otevřít nebo zavřít...");
        }

        System.out.format("--------------------%n");
        try {
            FileInputStream fis = new FileInputStream(soubor);
            Scanner cteckaSouboru = new Scanner(fis);

            System.out.format("Delimiter: %s%n", cteckaSouboru.delimiter().toString());
            Pattern pat = Pattern.compile(";");
            cteckaSouboru.useDelimiter(pat);
            System.out.format("Delimiter: %s%n", cteckaSouboru.delimiter().toString());

            while (cteckaSouboru.hasNext()) {
                System.out.format(cteckaSouboru.nextInt() + "%n");
            }
            fis.close();
        } catch (IOException ex) {
            System.out.format("Soubor nelze otevřít nebo zavřít...%n");
        } catch (InputMismatchException ex) {
            System.out.format("Obsah souboru je jiného typu, než se pokouším číst...%n");
        }

        System.out.format("-------- Binární čtení jednotlivých bytů ------------%n");
        try {
            FileInputStream fis = new FileInputStream(soubor);

            int cislo;
            while (fis.available() > 0) {
                cislo = fis.read();
                System.out.format("%d ", cislo);
            }
            fis.close();
        } catch (IOException ex) {
            System.out.format("%nSoubor nelze otevřít nebo zavřít...");
        }

        System.out.format("%n-------- Binární čtení jednoduchých datových typů ------------%n");
        System.out.format("-------- Binární čtení intů ------------%n");
        try {
            FileInputStream fis = new FileInputStream(soubor);
            DataInputStream dataFis = new DataInputStream(fis);

            int cislo;
            while (dataFis.available() > 0) {
                cislo = dataFis.readInt();
                System.out.format("%d ", cislo);
            }
            dataFis.close();
        } catch (IOException ex) {
            System.out.format("%nSoubor nelze otevřít...");
        }

        System.out.format("%n-------- Binární čtení doubleů ------------%n");
        try {
            FileInputStream fis = new FileInputStream(soubor);
            DataInputStream dataFis = new DataInputStream(fis);

            double cislo;
            while (dataFis.available() > 0) {
                cislo = dataFis.readDouble();
                System.out.format("%.16f ", cislo);
            }
            dataFis.close();
        } catch (IOException ex) {
            System.out.format("%nSoubor nelze otevřít nebo zavřít...");
        }

        String.format("%nDáme si do souboru nějaká čísla v binární podobě%n");
        try {
            FileOutputStream fw = new FileOutputStream(soubor);
            DataOutputStream dataFw = new DataOutputStream(fw);

            dataFw.writeDouble(256.789456478565656);
            dataFw.writeDouble(56.47);
            dataFw.writeDouble(6.4);
            dataFw.writeDouble(5.8);

            dataFw.writeInt(33);
            dataFw.writeInt(5);

            dataFw.close();
        } catch (IOException ex) {
            System.out.format("Soubor nelze otevřít nebo zavřít...");
        }

        System.out.format("%n-------- Binární čtení doublů ------------%n");
        try {
            FileInputStream fis = new FileInputStream(soubor);
            DataInputStream dataFis = new DataInputStream(fis);

            double cislo;
            while (dataFis.available() > 0) {
                cislo = dataFis.readDouble();
                System.out.format("%.16f ", cislo);
            }
            dataFis.close();
        } catch (IOException ex) {
            System.out.format("%nSoubor nelze otevřít nebo zavřít...");
        }

        System.out.format("%n-------- Otevření jako binárního souboru s náhodným přístupem ------------%n");
        try
        {
            RandomAccessFile fr = new RandomAccessFile("prejmenovany.txt", "rw");
            fr.setLength(4L);
        }
        catch(FileNotFoundException ex)
        {
            System.out.format("%nSoubor jsem nenašla...");
        } catch (IOException ex) {
            System.out.format("%nSoubor nelze otevřít nebo zavřít...");
        }
    } // konec main
}
